/**
* @author Aleksandr A. Lomov <lomov@cs.karelia.ru>
* @date   02.03.2015
* @brief  Base class for access point client.
*
* This file is part of the QT-SIB project.
*
* Copyright (C) 2015 by PetrSU.
* Contact: http://oss.fruct.org/wiki/SmartSpace-platform
*
* @section LICENSE
*
* QT-SIB is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* QT-SIB is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with QT-SIB; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor,
* Boston, MA  02110-1301  USA
*
* @section DESCRIPTION
*
* This class is used in the implementation of access point
* to represent a client.
**/

#ifndef ACCESSPOINTCLIENT_H
#define ACCESSPOINTCLIENT_H

//#include "accesspointinterface_global.h"
#include "accesspointinterface.h"

#include <QObject>

namespace cutesib {
namespace access_point {

//TODO: how to change: dosent store interafce in the request
// Forward declaration to compile (eliminate cross h. include)
class AccessPointInterface;

/**
 * @brief The base Client class to represent access point client.
 */
//class ACCESSPOINTINTERFACESHARED_EXPORT Client : public QObject
class Client : public QObject
{
    Q_OBJECT
public:

    /**
     * @brief Client class constructor.
     * @param parent. Parent for the instance.
     */
    explicit Client(QObject *parent = 0);

    /**
     * @brief ~Client class destructor.
     */
    virtual ~Client();
    virtual AccessPointInterface *getAccessPoint() = 0;

    QString nodeId();
    void setNodeId(QString nodeId);

private: // Fields
    QString nodeId_;
    //AccessPointInterface *accessPoint_;

    //virtual i
//    virtual getAddress() = 0;
//    virtual getPort() = 0;
};

} // namespace access_point
} // namespace cutesib


#endif // ACCESSPOINTCLIENT_H
