#-------------------------------------------------
#
# Project created by QtCreator 2015-03-08T21:51:49
#
#-------------------------------------------------

QT       += core

QT       -= gui

SIB_NAME = CuteSIB
SIB_CONFIG = cutesib.ini
SIB_CONFIG_PATH = ./$$SIB_CONFIG
VERSION = 0.1

windows {
    TARGET = CuteSIB
    TARGET_EXT = .exe
} else {
    TARGET = cutesib
}


unix {
    target.path = /usr/bin
    target.files = $$TARGET
    INSTALLS += target
}


# Now path configured for unix/linux
CONFIG(release, debug|release) {

    XDG_CONFIG_DIRS = $$(XDG_CONFIG_DIRS)
    !isEmpty(XDG_CONFIG_DIRS) {
        SIB_CONFIG_PATH = $$(XDG_CONFIG_DIRS)
        SIB_CONFIG_PATH = $$split(SIB_CONFIG_PATH, :)
        SIB_CONFIG_PATH = $$first(SIB_CONFIG_PATH)
        SIB_CONFIG_PATH = $$SIB_CONFIG_PATH/$$TARGET

    } else {
        SIB_CONFIG_PATH = /etc
    }

    message(Installing path for config: $$SIB_CONFIG_PATH)

    sibconfiguration.files = $$SIB_CONFIG
    sibconfiguration.path = $$SIB_CONFIG_PATH

    INSTALLS += sibconfiguration

    SIB_CONFIG_PATH = $$SIB_CONFIG_PATH/$$SIB_CONFIG
}

DEFINES += SIB_CONFIG_PATH=\\\"$$SIB_CONFIG_PATH\\\"
DEFINES += QT_NO_DEBUG_OUTPUT=1



QT_MESSAGE_PATTERN="[%{type}] %{appname} (%{file}:%{line}) - %{message}"


# Add target for Makefile to copy config file to 'build' dir.
!equals(PWD, $${OUT_PWD}) {
    copydata.commands = $(COPY_FILE) $$PWD/$$SIB_CONFIG $$OUT_PWD
    first.depends = $(first) copydata
    export(first.depends)
    export(copydata.commands)
    QMAKE_EXTRA_TARGETS += first copydata
} else {
    QMAKE_EXTRA_TARGETS += first
}

DEFINES += SIB_VERSION=\\\"$$VERSION\\\"
DEFINES += SIB_NAME=\\\"$$SIB_NAME\\\"
windows {
    DEFINES += SIB_AP_FOLDER=\\\"$$OUT_PWD/../TcpAccessPoint/debug\\\"
} else {
    DEFINES += SIB_AP_FOLDER=\\\"$$OUT_PWD/../TcpAccessPoint\\\"
}
#DEFINES += SIB_MESSAGE_PREFIX=\\\"==[$$SIB_NAME]==\\\"
#DEFINES += SIB_DEBUG_FNAME=Q_FUNC_INFO

windows {
    DEFINES += SIB_AP_EXT=\\\".dll\\\"
} mac {
    DEFINES += SIB_AP_EXT=\\\".dylib\\\"
} else  {
    DEFINES += SIB_AP_EXT=\\\".so\\\"
}

CONFIG   += console
CONFIG   -= app_bundle
CONFIG   += c++11

TEMPLATE = app


SOURCES += main.cpp \
    sibinitializer.cpp \
    accesspointmanager.cpp \
    ssaphandler.cpp \
    ssapparser.cpp \
    ssapmessage.cpp \
    sibconfig.cpp \
    logger.cpp \
    sib_operations.cpp \
    sib_reasoning.cpp \
    sib_sparql.cpp \
    sib_utilities.cpp \
    triple.cpp \
    ssapconstants.cpp \
    scheduler.cpp \
    command.cpp \

HEADERS += \
    sibinitializer.h \
    accesspointmanager.h \
    ssaphandler.h \
    ssapparser.h \
    ssapmessage.h \
    sibconfig.h \
    sibdebug.h \
    logger.h \
    siberrors.h \
    sib_data.h \
    sib_operations.h \
    sib_reasoning.h \
    sib_sparql.h \
    sib_utilities.h \
    triple.h \
    ssapconstants.h \
    scheduler.h \
    command.h \

win32:CONFIG(release, debug|release): LIBS += -L$$OUT_PWD/../AccessPointInterface/release/ -lAccessPointInterface
else:win32:CONFIG(debug, debug|release): LIBS += -L$$OUT_PWD/../AccessPointInterface/debug/ -lAccessPointInterface
else:unix: LIBS += -L$$OUT_PWD/../AccessPointInterface/ -lAccessPointInterface

INCLUDEPATH += $$PWD/../AccessPointInterface
DEPENDPATH += $$PWD/../AccessPointInterface

CONFIG += link_pkgconfig
PKGCONFIG += glib-2.0 redland rasqal expat libwhiteboard libssap_parse_n_gen libm3_parse_n_gen uuid
QMAKE_CXXFLAGS += -Wno-deprecated-declarations

DISTFILES += \
    cutesib.ini
