/**
* @author Aleksandr A. Lomov <lomov@cs.karelia.ru>
* @date   01.04.2015
* @brief  Scheduler manages commands processing.
*
* This file is part of the QT-SIB project.
*
* Copyright (C) 2015 by PetrSU.
* Contact: http://oss.fruct.org/wiki/SmartSpace-platform
*
* @section LICENSE
*
* QT-SIB is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* QT-SIB is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with QT-SIB; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor,
* Boston, MA  02110-1301  USA
*
* @section DESCRIPTION
*
* Scheduler manages commands in the SIB. Modules dosen't send commands
* directly beetwen each other. Commands are sends to scheduler and it
* gets information from the command to resend the command to appropriate
* reciever (other module).
**/



#ifndef COMMAND_H
#define COMMAND_H

#include <QObject>

#include <accesspointinterface.h>

namespace cutesib {

using namespace cutesib::access_point;

class Command : public QObject
{
    Q_OBJECT
public:
    explicit Command(Request *request, QObject *parent = 0);
    ~Command();

signals:
    void commandDone(int result);

public slots:

private: // Fields
    Request *ssapRequest_;

};

} // Namespace

#endif // COMMAND_H
