#include "logger.h"

#include <QDebug>

#include <stdio.h>


cutesib::Logger::Logger()
{

}

cutesib::Logger::~Logger()
{

}

QTextStream &cutesib::Logger::message()
{
    static QTextStream ts(stdout);
    return ts << " ";
}

QTextStream &cutesib::Logger::messageNames()
{
    return message() << "SIB_MESSAGE_PREFIX";
}




void cutesib::Logger::messageHandler(QtMsgType type, const QMessageLogContext &context, const QString &message)
{
    switch (type) {
    case QtDebugMsg:
        fprintf(stdout, "==[%s-Debug] - %s - %s\n", SIB_NAME, context.function,
                message.toStdString().c_str());
        fflush(stdout);
        break;
    case QtWarningMsg:
        fprintf(stderr, "==[%s-Warning] - %s - %s\n", SIB_NAME, context.function,
                message.toStdString().c_str());
        fflush(stderr);
        break;
    case QtCriticalMsg:
        fprintf(stderr, "==[%s-Critical] - %s - %s\n", SIB_NAME, context.function, message.toStdString().c_str());
        fflush(stderr);
        break;
    case QtFatalMsg:
        fprintf(stderr, "==[%s-Fatal] - %s - %s\n", SIB_NAME, context.function, message.toStdString().c_str());
        fflush(stderr);
        break;
    default:
        break;
    }
}
