/**
* @author Aleksandr A. Lomov <lomov@cs.karelia.ru>
* @date   01.04.2015
* @brief  Scheduler manages commands processing.
*
* This file is part of the QT-SIB project.
*
* Copyright (C) 2015 by PetrSU.
* Contact: http://oss.fruct.org/wiki/SmartSpace-platform
*
* @section LICENSE
*
* QT-SIB is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* QT-SIB is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with QT-SIB; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor,
* Boston, MA  02110-1301  USA
*
* @section DESCRIPTION
*
* Scheduler manages commands in the SIB. Modules dosen't send commands
* directly beetwen each other. Commands are sends to scheduler and it
* gets information from the command to resend the command to appropriate
* reciever (other module).
**/

// TODO: add project name
#ifndef CUTESIB_SCHEDULER_H
#define CUTESIB_SCHEDULER_H

#include <QObject>

#include "command.h"

namespace cutesib {


class Scheduler : public QObject
{
    Q_OBJECT
public:
    explicit Scheduler(QObject *parent = 0);
    ~Scheduler();

signals:

public slots:
    void commandReceived(Command *command);



};

}

#endif // CUTESIB_SCHEDULER_H
