#ifndef SIB_OPERATIONS_H
#define SIB_OPERATIONS_H

#include <glib.h>
#include <redland.h>
#include <rasqal.h>
#include <stdlib.h>
#include <string.h>
#include <sibmsg.h>
#include <unistd.h> // for usleep
//#include <whiteboard_node.h>
#include <uuid/uuid.h>

#include "sib_sparql.h"

//RDF DEFINE
#define wildcard1 	"sib:any"
#define wildcard2 	"http://www.nokia.com/NRC/M3/sib#any"

#define fn_ex 		"http://www.w3.org/2005/xpath-functions#"
#define fn_c_1 		"fn#"
#define fn_c_2 		"fn:"

#define rdf_ex 		"http://www.w3.org/1999/02/22-rdf-syntax-ns#"
#define rdf_c 		"rdf:"

#define xsd_ex		"http://www.w3.org/2001/XMLSchema#"
#define xsd_c 		"xsd:"

#define rdfs_ex		"http://www.w3.org/2000/01/rdf-schema#"
#define rdfs_c		"rdfs:"

#define subs_uri	"http://subscribe_graph#"

//int file_exists(gchar *filename);




/***** Subscription indication *****/
#include <QObject>

typedef struct subs_ind_s {
    char *ssap_message;
    char *node_id;
    char *subs_id;
} subs_ind_t;

class IndicatorMessanger : public QObject
{
    Q_OBJECT
public:
    explicit IndicatorMessanger(QObject *parent = 0);
    ~IndicatorMessanger();
    void sendIndicationEvent(subs_ind_t *ind);

signals:
    void indicationReady(subs_ind_t *indication);
public slots:

 };



IndicatorMessanger* getIndcationMessnger();

void add_subs_ind(subs_ind_t *ind);
subs_ind_t* get_subs_ind();

void handle_subscription_ind(gchar *spaceid,
        gchar *nodeid,
        gint msgnum,
        gint seqnum,
        gchar *subscription_id,
        gchar *results_new,
        gchar *results_obsolete);
/************************************/


void add_triplelist_in_submodel( sib_data_structure* p, ssap_sib_message * rsp, GSList * triplelist);
void remove_triplelist_in_submodel( sib_data_structure* p, ssap_sib_message * rsp, GSList * triplelist);

void ssFreeTriple( ssTriple_t *triple);
void ssFreeTripleList (GSList **tripleList);

int client_receive_message(char* message, NodeMsgContent_t* msg);
void listener_handle_request(NodeMsgContent_t *msg, sib_data_structure *sib_data);
char *listener_handle_insert(NodeMsgContent_t *msg, sib_data_structure *sib_data);
char* listener_handle_remove(NodeMsgContent_t *msg, sib_data_structure* sib_data);
char *listener_handle_update(NodeMsgContent_t *msg, sib_data_structure* sib_data);
char *listener_handle_query(NodeMsgContent_t *msg, sib_data_structure* sib_data);
char* listener_handle_subscribe(NodeMsgContent_t *msg, sib_data_structure *sib_data);
char* listener_handle_unsubscribe(NodeMsgContent_t *msg, sib_data_structure *sib_data);
char* listener_handle_unsubscribe(NodeMsgContent_t *msg, sib_data_structure *sib_data);

ssap_sib_message* m3_insert(sib_data_structure* sib, gchar* spaceid, gchar* nodeid, gint msgnumber, EncodingType encoding, const char* insert_str);
int m3_remove(sib_data_structure* sib, gchar* spaceid, gchar* nodeid, gint msgnumber, EncodingType encoding, const char* remove_str);
ssap_sib_message* m3_update(sib_data_structure* sib, gchar* spaceid, gchar* nodeid, gint msgnumber, EncodingType encoding, char* insert_str, char* remove_str);
ssap_sib_message* m3_query_spql_upd(sib_data_structure* sib, gchar* spaceid, gchar* nodeid, gint msgnumber, query_type qtype, const char* query_str);
int m3_subscribe(sib_data_structure* sib, gchar* spaceid, gchar* nodeid, gint msgnumber, query_type qtype, const char* query_str,
                 gchar** subscription_id, gchar** results, GCond* sub_cond);
gint m3_subscribe_triples(ssap_message_header *header,
        ssap_kp_message *req_msg, ssap_sib_message *rsp_msg,
        sib_data_structure* sib, gchar** subscription_id, gchar** results, GCond* sub_cond);
gint m3_subscribe_sparql(ssap_message_header *header,ssap_kp_message *req_msg, ssap_sib_message *rsp_msg,
                         sib_data_structure* sib, gchar** subscription_id, gchar** results, GCond* sub_cond);
int m3_unsubscribe(sib_data_structure* sib, gchar* spaceid, gchar* nodeid, gint msgnumber, gchar* sub_id);

gpointer subscribe_thread(gpointer data);

sib_data_structure* sib_initialize(gchar* name, gpointer parameter_list);

gpointer scheduler(gpointer data);

void do_insert(gpointer op_param, gpointer p_param);
void do_query_subscribe(gpointer op_param, gpointer p_param);
void set_sub_to_pending(gpointer sub_id, gpointer sub_data, gpointer unused);
void set_sub_to_ongoing(gpointer sub_id, gpointer sub_data, gpointer unused);

ssStatus_t rdf_reader(scheduler_item* op, sib_data_structure* p);
ssStatus_t rdf_writer(scheduler_item* op, sib_data_structure* param);
ssStatus_t rdf_retractor(scheduler_item* op, sib_data_structure* param);
void rdf_subscribe(scheduler_item* op, sib_data_structure* param);

gboolean load_rdf_subscriptions(scheduler_item* op, sib_data_structure* sib_data);
gboolean threadsub_wake_if_unsub(scheduler_item* op, sib_data_structure* p);
void threadsub_wake_and_reload_op(scheduler_item* op, sib_data_structure* p);
void threadsub_try_not_wake_reload_op(scheduler_item* op, sib_data_structure* p);

gboolean load_seq_i_r_to_async_ts(scheduler_item* op, sib_data_structure* p);
gboolean load_sparql_booster_subscriptions(scheduler_item* op, sib_data_structure* p);
gboolean check_add_rm_on_substore_from_i_r(ssap_kp_message *req, ssap_sib_message* rsp );

void destroy_recycle_world_sub_ts(ssap_sib_message* rsp, sib_data_structure* p);
void generate_recycle_world_sub_ts(ssap_sib_message* rsp, sib_data_structure* p);







#endif // SIB_OPERATIONS_H
