#ifndef SIB_DATA_REASONING_H
#define SIB_DATA_REASONING_H

#include <sibdefs.h>
#include "sib_data.h"
#include "sib_utilities.h"

gchar* control_string_expand(ssElement_t thing);
ssTriple_t* trasform_statement_expand(ssTriple_t* stat);

gchar* control_string_contract(ssElement_t thing);
ssTriple_t* trasform_statement_contract(ssTriple_t* stat);

void reasoning(sib_data_structure* param, ssTriple_t* t, gboolean enable_real_reasoning);
void check_subtype_and_add(sib_data_structure* param, gchar* uri, gchar* class_or_subclass);
void add_sub_type(sib_data_structure* param, gchar* sub_class, gchar* _class);
void add_sub_properties(sib_data_structure* param, gchar* sub_property, gchar* property);
void  add_properties_domain(sib_data_structure* param, gchar* property, gchar* _class);
void  add_properties_range(sib_data_structure* param, gchar* property, gchar* _class);
void check_if_property_in_domain_and_add_subject_type(sib_data_structure* param, gchar* uri, gchar* property);
void check_if_predicate_subproperty_and_add(sib_data_structure* param, gchar* uri, gchar* property ,gchar* object);
void check_if_property_in_range_and_add_object_type(sib_data_structure* param, gchar* uri, gchar* property);

#endif // SIB_DATA_REASONING_H
