#ifndef SSAPCONSTANTS_H
#define SSAPCONSTANTS_H


#include <QString>


namespace cutesib {

class SsapConstants
{
private:
    SsapConstants();
public:
    ~SsapConstants();

    // SSAP request/response
    static const QString MessageTypeRequest;
    static const QString MessageTypeResponse;


    // SSAP transactions/messages.
    static const QString TransactionTypeJoin;
    static const QString TransactionTypeLeave;
    static const QString TransactionTypeInsert;
    static const QString TransactionTypeUpdate;
    static const QString TransactionTypeRemove;
    static const QString TransactionTypeQuery;
    static const QString TransactionTypeSubscribe;
    static const QString TransactionTypeUnsubscribe;


    // Tags
    static const QString TagParameter;

    // Tags for triples
    static const QString TagTripleList;
    static const QString TagTriple;
    static const QString TagSubject;
    static const QString TagPredicate;
    static const QString TagObject;

    static const QString AttributeName;
    static const QString AttributeEncoding;
    static const QString AttributeType;



    static const QString AttributeValueRdfM3;


    // SSAP attributes values.
    static const QString AttributeValueInsertGraph;
    static const QString AttributeValueConfirm;

    // SSAP attributes values for RDF types
    static const QString AttributeValueRdfTypeUri;
    static const QString AttributeValueRdfTypeLiteral;

};

}

#endif // SSAPCONSTANTS_H
